#ifndef MYFITTER_COMPARISON_HPP
#define MYFITTER_COMPARISON_HPP

#include <algorithm>

namespace myfitter {

template<class R, class T>
inline R rel_diff(const T& a, const T& b)
{
    R moda = std::abs(a);
    R modb = std::abs(b);
    if((moda == 0) && (modb == 0))
        return moda;
    else
        return std::abs(a - b)/std::max<R>(moda, modb);
}

template<class R, class T>
inline bool differ(const T& a, const T& b, R rel_prec, R abs_prec)
{
    R moda = std::abs(a);
    R modb = std::abs(b);
    if((moda <= abs_prec) && (modb <= abs_prec))
        return false;
    else if(std::abs(a - b)/std::max<R>(moda, modb) <= rel_prec)
        return false;
    else
        return true;
}

}

#endif
